/*
 * Copyright (c) 2003 by Hansjoerg Lipp (hjlipp@web.de)
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef GIGASET_CONF_H
#define GIGASET_CONF_H

#include <stdint.h>

struct gconf {
	struct gconf *next;
	uint16_t id;
	uint8_t tid;
	uint8_t datatype;
	uint16_t len;
	char *buf;
	union /* can be used by the caller */
	{
		unsigned long data;
		void *ptr;
	} priv;
};

int_fast32_t gigaset_confread(struct gstatus *gs, uint16_t id, uint8_t tid, uint8_t datatype, char **buf);
int gigaset_confwrite(struct gstatus *gs, uint16_t id, uint8_t tid, uint8_t datatype, const char *buf, uint16_t l);
int gigaset_confreadarray(struct gstatus *gs, struct gconf *list);
int gigaset_confinitlock(struct gstatus *gs);
int gigaset_confkeeplock(struct gstatus *gs);
int gigaset_confunlock(struct gstatus *gs);

#endif /* GIGASET_CONF_H */
