/*
 * Copyright (c) 2003 by Hansjoerg Lipp (hjlipp@web.de)
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef GIGASET_LOG_H
#define GIGASET_LOG_H

#include "interf.h"

#define ELTYPE_FORMAT	0x300	/* bitmask for element data format */
#define ELTYPE_CBUF	0x000	/* format: byte sequence with length */
#define ELTYPE_NUMBER	0x100	/* format: unsigned binary number */
#define ELTYPE_STRING	0x200	/* format: null-terminated string */
#define ELTYPE_CHRG	0x300	/* format: charging information */

struct glogel {
	int type;
	unsigned num;	/* ELTYPE_CBUF: length */
			/* ELTYPE_NUMBER, ELTYPE_CHRG: value */
	char *str;	/* ELTYPE_CBUF, ELTYPE_STRING: data */
			/* ELTYPE_CHRG: currency if subtype 'C', else NULL */
	int scale;	/* ELTYPE_CHRG: exponent if str!=NULL */
};

struct glogrec {
	int recid;	/* record ID */
	int year;	/* date */
	int month;
	int day;
	int hour;	/* time */
	int min;
	int sec;
	int type;
	int nels;	/* number of data elements */
	struct glogel el[1];
};

int gigaset_logstatus(struct gstatus *gs, unsigned *pid, unsigned *pnum);
int gigaset_logdel(struct gstatus *gs);
int gigaset_logread(struct gstatus *gs, uint32_t id, struct glogrec **prec);

#endif /* GIGASET_LOG_H */
