/*
 * Copyright (c) 2003 by Hansjoerg Lipp (hjlipp@web.de)
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef _GIGASET_M10X_H_
#define _GIGASET_M10X_H_

#include "interf.h"

struct m10x_state
{
	int mode;
	int baudrate;
	int format;
	int handshake;
	int flow;
	int type;
	int partner;
};

int m10x_connected (struct gstatus * gs);
int m10x_vendor (struct gstatus * gs, int adapter, char ** buf);
int m10x_getname (struct gstatus * gs, int adapter, char ** buf);
int m10x_devid (struct gstatus * gs, int adapter, char ** buf);
int m10x_version (struct gstatus * gs, int adapter, char ** buf);
int m10x_versionhw (struct gstatus * gs, int adapter, char ** buf);
int m10x_connstate(struct gstatus *gs, char **buf);
int m10x_field (struct gstatus * gs, char ** buf);
int m10x_quality (struct gstatus * gs, char ** buf);
int m10x_listautorel(struct gstatus *gs, int adapter, unsigned int **list);
int m10x_listconns(struct gstatus *gs, int adapter, unsigned int **list);
int m10x_occupyconn(struct gstatus *gs);
int m10x_releaseconn(struct gstatus *gs);
int m10x_setautorel(struct gstatus *gs, int secs);
int m10x_reset (struct gstatus * gs);
int m10x_listen (struct gstatus * gs);
int m10x_settype (struct gstatus * gs, int type);
int m10x_register (struct gstatus * gs, const char * pin, int index);
int m10x_setstate (struct gstatus * gs, const struct m10x_state * mstate);
int m10x_getstate (struct gstatus * gs, struct m10x_state * mstate);
int m10x_adapterlist(struct gstatus *gs, int adapter, char ***list);
int m10x_setpartner(struct gstatus *gs, unsigned partner);

#endif /* _GIGASET_M10X_H_ */
