/*
 * Copyright (c) 2003 by Hansjoerg Lipp (hjlipp@web.de)
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef _GIGASET_PHONEBOOK_H_
#define _GIGASET_PHONEBOOK_H_

#define PB_TRANSFER_AUTO	0
#define PB_TRANSFER_OLD		1
#define PB_TRANSFER_NEW		2

struct gphonebook
{
	struct gphonebook *next;
	const char *name;
	const char *number;
	const char *pnr;
	int melody;
	int alert;
	int day;
	int month;
	int year;
	int hour;
	int minute;
	char *buffer;
};

int gigaset_sendpbarray (struct gstatus * gs, struct gphonebook * list);
int gigaset_pbent (struct gstatus * gs, const char * nmbr, const char * name, const char * pnmbr);
int gigaset_readpbarray(struct gstatus *gs, struct gphonebook **list, const char *pnmbr, int method);
int gigaset_delpb (struct gstatus * gs, const char * nmbr);

#endif //_GIGASET_PHONEBOOK_H_

