/*
 * Copyright (c) 2006 by Hansjoerg Lipp <hjlipp@web.de>
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef APPLICATION_H
#define APPLICATION_H

#include <QtGui>
#include <signal.h>
//#include <qmutex.h>
#include "gigasetqt.hh"
#include "logger.hh"

class QAction;
class QMenu;
class QWorkspace;
//class MdiChild;
class QSignalMapper;

class ApplicationWindow: public QMainWindow
{
	Q_OBJECT
public:
	ApplicationWindow();
	~ApplicationWindow();

protected:
	void closeEvent(QCloseEvent* event);
private slots:
/*
	MDIWindow* newDoc();
	void load();
	void save();
	void saveAs();
	void print();

	void cut();
	void copy();
	void paste();
*/
	void openDevice();
	void closeDevice();

	void devInfo();

	void smsBrowse();
	void smsNew();

	void config();
	void dial();

	//void closeWindow();
	//void tileHorizontal();

	void about();

	void updateMenus();
	void updateWindowMenu();

	void showLogList();

signals:
	void logMessage(unsigned int level, QByteArray msg);
private:
	void createActions();
	void createMenus();
	void createToolBars();
	void createStatusBar();
	void readSettings();
	void writeSettings();
/*
    QPrinter *printer;
    QToolBar *fileTools;
*/
	QWorkspace* ws;
	QMenu *windowMenu;
	QMenu *deviceMenu;
	//QMenu *editMenu;
	QMenu *smsMenu;
	QMenu *helpMenu;

	LogList *loglist;

	//QString deviceName;
	struct GigasetQt gs;

	Logger logger;

	QSignalMapper *windowMapper;

	QAction *devOpenAct;
	QAction *devCloseAct;
	//QAction *cutAct;
	//QAction *copyAct;
	//QAction *pasteAct;
	QAction *smsBrowseAct;
	QAction *smsNewAct;
	QAction *logListAct;
	QAction *devInfoAct;
	QAction *dialAct;
	QAction *configAct;
	QAction *exitAct;
	QAction *closeAct;
	QAction *closeAllAct;
	QAction *tileAct;
	QAction *cascadeAct;
	//QAction *arrangeAct;
	QAction *nextAct;
	QAction *previousAct;
	QAction *separatorAct;
	QAction *aboutAct;
	QAction *aboutQtAct;
};

class DeviceDialog: public QDialog {
	Q_OBJECT
public:
	static QString chooseDevice(QWidget *parent, GigasetQt &gsq);
private:
	GigasetQt &gs;
	QComboBox *cb;
	DeviceDialog(QWidget *parent, GigasetQt &gsq);
};

#endif
