/*
 * Copyright (c) 2006 by Hansjoerg Lipp <hjlipp@web.de>
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef DIAL_HH
#define DIAL_HH

#include <QtGui>
#include "gigasetqt.hh"

class DialThread: public QThread
{
	Q_OBJECT
public:
	DialThread(GigasetQt &gigaset);
	int dial(unsigned type, const QString to, const QString from);
	void abort();
	~DialThread();
signals:
	void done(int error);
protected:
	void run();

private:
	QMutex mutex;
	QWaitCondition condition;
	bool abortthread;
	bool dialing;

	GigasetQt &gs;
	QString numTo;
	QString numFrom;
	unsigned typeTo;
};

class DialWidget: public QWidget
{
	Q_OBJECT
public:
	DialWidget(GigasetQt &gigaset, QWidget *parent = 0);
	~DialWidget();
protected:
	void closeEvent(QCloseEvent*);
private slots:
	void dial();
	void abort();
	void done(int error);
signals:
	void message(const QString&, int);
	void dialing(bool);
private:
	GigasetQt &gs;
	DialThread dialthread;
	QLineEdit *numFrom;
	QLineEdit *numTo;
	QComboBox *typeTo;
};


#endif
