/*
 * Copyright (c) 2006 by Hansjoerg Lipp <hjlipp@web.de>
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef SMSCREATOR_HH
#define SMSCREATOR_HH

#include <QtGui>
#include "gigasetqt.hh"
extern "C" {
#include <gigaset/sms.h>
}

class VPSpinBox: public QSpinBox
{
	Q_OBJECT
public:
	VPSpinBox(QWidget * parent = 0);
	QValidator::State validate(QString &input, int &pos) const;
protected:
	QString textFromValue(int val) const;
	int valueFromText(const QString &text) const;
};

class SmsCreator: public QWidget
{
	Q_OBJECT

public:
	SmsCreator(GigasetQt &gigaset, QWidget *parent = 0);
	~SmsCreator();
protected:
	void closeEvent(QCloseEvent*);
public slots:
private slots:
	void send();
signals:
	void message(const QString&, int);
private:
	int sms_create(struct gigaset_sm *msg, const char *number, bool store);
	GigasetQt &gs;
	QTextEdit *teMessage;
	QLineEdit *leNumber;
	QComboBox *cbType;
	VPSpinBox *sbVP;
	QSpinBox *sbChainID;
	QCheckBox *cbLarge, *cbStore;
	QPushButton *bSend;
};

#endif
