/*
 * Copyright (c) 2006 by Hansjoerg Lipp <hjlipp@web.de>
 *
 * =====================================================================
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License as
 *      published by the Free Software Foundation; either version 2 of
 *      the License, or (at your option) any later version.
 * =====================================================================
 */

#ifndef SMSLIST_HH
#define SMSLIST_HH

#include <QtGui>
#include "gigasetqt.hh"
extern "C" {
#include <gigaset/sms.h>
}

class SmsListViewItem: public QTreeWidgetItem
{
public:
	SmsListViewItem(QTreeWidget *parent, struct gigaset_sm *m)
		: QTreeWidgetItem(parent), msg(m)
		{ init(); }
	SmsListViewItem(QTreeWidgetItem *parent, struct gigaset_sm *m)
		: QTreeWidgetItem(parent), msg(m)
		{ init(); }
	SmsListViewItem(QTreeWidget *parent, QTreeWidgetItem *preceding, struct gigaset_sm *m)
		: QTreeWidgetItem(parent, preceding), msg(m)
		{ init(); }
	SmsListViewItem(QTreeWidgetItem *parent, QTreeWidgetItem *preceding, struct gigaset_sm *m)
		: QTreeWidgetItem(parent, preceding), msg(m)
		{ init(); }
	struct gigaset_sm *getMsg() const { return msg; }
private:
	void init();
	struct gigaset_sm *msg;
};

class SmsList: public QWidget
{
	Q_OBJECT

public:
	SmsList(GigasetQt &gigaset, QWidget *parent = 0);
	~SmsList();
protected:
	void closeEvent(QCloseEvent*);
public slots:
	int load();
private slots:
	int del();
	//void updateText(QListViewItem *); //FIXME
	void updateText(QTreeWidgetItem *cur, QTreeWidgetItem *prev);
signals:
	void message(const QString&, int);
private:
	int delItem(SmsListViewItem *); //FIXME
	//void createSmsItem(QListViewItem *item, struct gigaset_sm *msg);
	GigasetQt &gs;
	//QListView *lv;
	//QTreeView *tv;
	//QDirModel *dm;
	QTreeWidget *tw;
	QTextEdit *te;
	struct gigaset_sm *messages;
	struct gigaset_sm_chain *chains;
};

#endif
